#ifndef SPORTNGOSD_H
#define SPORTNGOSD_H

#include <string>

#include <vdr/osd.h>
#include <vdr/menu.h>

// -------------------------- Hauptmen-------------------------- //
// OSD MENU##################################################
class cSportNGHelpKeys
{
private:
	char *helpKeys[4];
	char *helpCommands[4];
protected:
	cSportNGHelpKeys();
	~cSportNGHelpKeys();
	void SetHelpKeyAndCommand(int Idx, const char *HelpKey, const char* Command);
	void SetHelpKeyAndCommand(int Idx, char *KeyAndCommand);
	void	ClearHelpKeys();
public:
	const char *GetHelpCommand(int Idx);	// 0=red, 1=green, 2=yellow, 3=blue 
	char **GetHelpKeys(char *HelpKeys[], bool CpyAll);
};


class cSportNGBase : public cSportNGHelpKeys
{
private:
	char		*pFileName;
	time_t	FileTime;
	static int running;
public:
	cSportNGBase();
	virtual ~cSportNGBase();
protected:
	const char *GetFileName(void) { return pFileName; }
	time_t GetFileDate(void) { return FileTime; }
	virtual bool LoadContent(const char *File);
	virtual void SetContent(const char *Text, bool i18n=true, bool fromLoad=false)=0;
	virtual eOSState AddSubMenu(cOsdMenu *SubMenu)=0;
   virtual eOSState ParseCommand(const char* Command);
   static int Running() { return running; }
};

class cSportNG : public cSportNGBase, public cOsdMenu {
public:
	cSportNG(const char *File=0);
private:
	int lastItem;
//	int GetAverageCharacterWidth(void);
#define AverageCharacterWidth	(max(14-SportNGSetup.s_adjust2,5))
	int GetTextAreaWidth();
	void CalcColWidth(const char *Text, int ColWidth[6], int LastColWidth[6]);
protected:
	virtual void SetContent(const char *Text, bool i18n=true, bool fromLoad=false);
	virtual eOSState AddSubMenu(cOsdMenu *SubMenu){return cOsdMenu::AddSubMenu(SubMenu);}
	void DisplayHelpKeys(bool Force=false);
public:
	virtual eOSState ProcessKey(eKeys Key);	
//	static bool reloadData(bool Force=true);
	static cOsdMenu *reloadData(bool Force=true);
};

class cSportNGMenuText : public cSportNGBase, public cMenuText
{
public:
	cSportNGMenuText(const char *File, bool isText=false);
private:
protected:
	virtual void SetContent(const char *Text, bool i18n=true, bool fromLoad=false);
	virtual eOSState AddSubMenu(cOsdMenu *SubMenu){return cMenuText::AddSubMenu(SubMenu);}
	void DisplayHelpKeys();
public:
	virtual eOSState ProcessKey(eKeys Key);
};

#endif // __SPORTNGOSD_H
